// classify_atom.c
//
// 15 Nov 2004 K.Tonomura
// 24 Jul 2008 T.Ohya

#include "classify_atom.h"

int view_neighbor = 0;
int oh_flg = 1;  // when oh_flg = 1, O(-) = OH
int h_count_ast = 1;  // when  h_count_ast = 1 , consider * comme H

string classify_C(molform * ,int **  , int);

int **get_neighboring(molform moltmp , int **cmat , int num , int iEdge) {
  int **neighbor;
  int count = 0;
  int cbond = 0;
  int iEdge_wk = iEdge;

  neighbor = matrix_new(2,10);
  neighbor[0][0] = 0;
  neighbor[1][0] = 0;

  // consider O(-) comme H

  if( moltmp.ihy == 1 ) {
//    if( moltmp.atomsymbol[num] == "O" && moltmp.charge[num] == 5 ) {
    if( moltmp.charge[num] == 5 ) {
      iEdge_wk ++;
      cout << moltmp.name << ":" << num << ": " << moltmp.atomsymbol[num] << "(-) => " << moltmp.atomsymbol[num] << "H " << endl;
    }
  }

  for( int i=0 ; i < moltmp.nodenum ; i ++ ) {
    if( cmat[num][i] != 0 ) {
      count ++;
      neighbor[0][count] = i;
      neighbor[1][count] = cmat[num][i];
      cbond = cbond +  cmat[num][i];
      //      if( cmat[num][i] == 4 ) {
      //	cout << "[" << num << "][" << i << "]" << endl;
      //     }
    }
  }
  neighbor[0][0] = count;
  neighbor[1][0] = cbond;

  int abond = check_aromanode(moltmp , num );

  if( abond > 0 ) {
   
    if( iEdge_wk < 3 ) {
      if( moltmp.atomsymbol[num] != "O" && iEdge_wk != 2 ) {
	cout << moltmp.name << ":" << num << ": " << moltmp.atomsymbol[num] << " illigal aromatic bonds." << endl;
      }

    } else {

	int aroma_atoms = 0;
	int non_aroma_edges = 0;
	for( int j = 1 ; j <= neighbor[0][0] ; j ++ ) {
	  if( neighbor[1][j] == 4 ) 
	    aroma_atoms ++;
	  else
	    non_aroma_edges = non_aroma_edges + neighbor[1][j];
	} 
	int aroma_edge = int( aroma_atoms * 1.5 ) + non_aroma_edges ;

//	cout << aroma_edge << ":" << iEdge_wk << endl;
	while( aroma_edge < iEdge_wk ) {
	  aroma_edge ++;
	  neighbor[0][0] ++;
	  neighbor[1][0] ++;
	  neighbor[0][ neighbor[0][0]  ] = -1; // -1 est H
	  neighbor[1][ neighbor[0][0]  ] = 1;
	  //	cout << "*";
	}  
	//	} 
    }
    //    print_neighbor( neighbor , moltmp);

  } else { 
    
    if( iEdge_wk > 0 ) {
      // compenste H for the set of neighbors
      
      //    cout << "(-_-)" << neighbor[1][0] << ":" << iEdge << endl;
      if( neighbor[1][0] < iEdge_wk ) {
	while( neighbor[1][0] < iEdge_wk ) {
	  neighbor[0][0] ++;
	  neighbor[1][0] ++;
	  neighbor[0][ neighbor[0][0]  ] = -1; // -1 est H
	  neighbor[1][ neighbor[0][0]  ] = 1;
	  //	cout << "*";
	}  
      } 
    }
  }

  return neighbor;
}
// end get_neighboring

int compaire_atom(int num, string atom , molform moltmp ) {
  if( num == -1 ) {
    if( atom == "H" ) 
      return 1;
    else 
      return 0;
  } else {
    if( moltmp.atomsymbol[num] == atom ) 
      return 1;
    else
      return 0;
  }
  return 0;
}

int count_neighbor_aroma_bond( int **neighbor ) {
  //  cout << neighbor[0][0] << ":" << neighbor[1][0] <<  "=";
  int ret = 0;
  for(int i=1; i <= neighbor[0][0]; i++ ){
    if( neighbor[1][i] == 4  )
      ret ++;
  }
  return ret;
}

int count_neighbor_non_aroma_bond( int **neighbor ) {
  //  cout << neighbor[0][0] << ":" << neighbor[1][0] <<  "=";
  int ret = 0;
  for(int i=1; i <= neighbor[0][0]; i++ ){
    if( neighbor[1][i] != 4  )
      ret = ret +  neighbor[1][i];
  }
  return ret;
}

int hydrogen_count(int **neighbor , molform moltmp ) {
  int count = 0;
  for(int i = 1 ; i <= neighbor[0][0] ; i++ ){
    if( neighbor[0][i] == -1 ) {
      count ++ ;
    } else {
      if( moltmp.atomsymbol[neighbor[0][i]] == "H" )
	count ++;
      else if ( h_count_ast == 1 && moltmp.atomsymbol[neighbor[0][i]] == "*" ) {
	cout << moltmp.name << ": * => H " << endl;
	count ++;
      }
    }
  }
  return count;
}

void print_neighbor(int **neighbor , molform moltmp ) {
  cout << neighbor[0][0] << ":" << neighbor[1][0] <<  "=";
  for(int i=1; i <= neighbor[0][0]; i++ ){
    string strWk = "H";
    if( neighbor[0][i] > -1 )
      strWk = moltmp.atomsymbol[neighbor[0][i]];
    cout << strWk << ":" <<  neighbor[1][i] << " ";
  }
  cout << endl;
}

int atom_count(int **neighbor , molform moltmp , string atom) {
  int count = 0;
  for(int i = 1 ; i <= neighbor[0][0] ; i++ ) {
    if( neighbor[0][i] != -1 ) {
      if( moltmp.atomsymbol[neighbor[0][i]] == atom )
	count ++;
    }
  }
  //  cout << "fini" << endl;
  return count;
}

int check_OH( molform moltmp , int **cmat , int atom_num , int org_atom ) {
  int **neighbor_atom_oh;
  int ret = 0;

  //  cout << "*";

  if( moltmp.atomsymbol[ atom_num ] == "O" ) {

    //    cout << "(>o<)";

    neighbor_atom_oh = get_neighboring(moltmp , cmat , atom_num , 2  );

    if ( neighbor_atom_oh[0][0] == 1 ) {
      //      cout << "OUI!" << endl;
      // 隣接原子が1つしかない 
      if ( neighbor_atom_oh[0][1] == org_atom ) {
	// しかもそれは 検索元だった
	if( neighbor_atom_oh[1][1] == 1 ) {
	  // 二重結合じゃなかったって事は Hは省略されてるのね
	  ret = 1;
	  //	  cout << "E:" << atom_num << ":" << org_atom << endl;
	}
      } else {
	cout << moltmp.name << ": OH check error!!! ：ommition of a H from a molecule : " << moltmp.atomsymbol[atom_num] << ":" <<   moltmp.atomsymbol[neighbor_atom_oh[0][1]] << endl;
	exit(1);
      }
    } else if ( neighbor_atom_oh[0][0] == 2 ) {
      //      cout << "NON!" << endl;
      if (  neighbor_atom_oh[0][1] == org_atom ) { 
	if( neighbor_atom_oh[0][2] == -1 ) {
	  //	  	  cout << "A:" <<  neighbor_atom_oh[0][1] << ":" << neighbor_atom_oh[0][2] << endl;
	  ret = 1;
	} else if( moltmp.atomsymbol[neighbor_atom_oh[0][2]] == "H" ) { // C6a
	  //	  	  cout << "B" << endl;
	  ret = 1;
	}
      } else if (  neighbor_atom_oh[0][2] == org_atom ) {
	if( neighbor_atom_oh[0][1] == -1 ) {
	  //	  	  cout << "C" << endl;
	  ret = 1;
	} else if( moltmp.atomsymbol[neighbor_atom_oh[0][1]] == "H" ) { // C6a
	  //	  	  cout << "D" << endl;;
	  ret = 1;
	}
      } else {
	//	cout << moltmp.name << ": OH check error!!! : discorrect from neighbor point" << endl;
	exit(1);
      }
    } else if( neighbor_atom_oh[0][0] == 3  && moltmp.charge[ atom_num ] == 5){
      // 電離しているときは、OH補整とバッティングして腕が一本多く出てしまう
      if( hydrogen_count( neighbor_atom_oh , moltmp) == 2 )
	ret = 1;
    }
    matrix_del(neighbor_atom_oh,2);
  } else {
    //    cout << moltmp.name << ": this in not Oxgen! " << ret << " " << atom_num  << moltmp.atomsymbol[ atom_num ] << ":" << org_atom << endl;
  }
  return ret;
}

string classify_C(molform moltmp , int **cmat , int num) {
  string symbol;
  symbol = "C0";
  int **neighbor_atom;
  int iEdge = 4;

  if( moltmp.charge[num] >=1 && moltmp.charge[num] <=7 )
    iEdge = iEdge + ( 4 - moltmp.charge[num]);
  neighbor_atom = get_neighboring(moltmp,cmat,num , iEdge);
   
  if( neighbor_atom[1][0] > iEdge ) {
    if( moltmp.ihy == 0 || ( moltmp.ihy == 1 && neighbor_atom[1][0] - iEdge != 1) ) {
      cout << moltmp.name << " : Edge Count Error (C) Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
      cout << moltmp.name << " : neighbor atom " ;
      print_neighbor( neighbor_atom , moltmp );
      //    exit(1);
    }
  }

  if( moltmp.charge[num] == 5 ) {
    cout << moltmp.name << " : Carbon(-) " << num << " " << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << endl;
    //    cout << moltmp.name << " : neighbor atom " ;
    //   symbol = "C0";
    //    matrix_del(neighbor_atom,2);
    //   return symbol;
  }

  int iHyd = hydrogen_count(neighbor_atom,moltmp);

  int DEdge = 0;
  int TEdge = 0;

  // 腕の数だけで分類できれば良いのだけど、Cが電離しているとそうもいかないので
  // DEdge と TEdge を導入。 

  for( int i = 1; i <=  neighbor_atom[0][0] ; i ++ )
    if( neighbor_atom[1][i] == 2 ) 
      DEdge ++;
    else if( neighbor_atom[1][i] == 3 )
      TEdge ++;
  
  if( DEdge + TEdge == 0  ) {
  //  if( neighbor_atom[0][0] == 4 ) {
    // 腕が4本 C1a - C1d
    if( iHyd == 4 ) 
      symbol = "C0";  // R は必ずHでない条件
    else if( iHyd == 3 ) 
      symbol = "C1a";
    else if( iHyd == 2 ) 
      symbol = "C1b"; 
    else if( iHyd == 1 ) 
      symbol = "C1c";
    else if( iHyd == 0 ) 
      symbol = "C1d";
    else { 
      cout << "C4-lineの処理で何かポカをしているぞ : " << neighbor_atom[0][0] << ":" <<  iHyd <<  endl;
      exit(1);
    }

  } else if( TEdge > 0) {

    if( DEdge > 0 ) {
      cout << moltmp.name << " : Edge Count Error (C) Triple Edge & Double Edge!!!  Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
      symbol = "C0";

    } else if( iHyd != 0 )  
      symbol = "C3a";
    else 
      symbol = "C3b";

    //  } else if( neighbor_atom[0][0] == 3 && DEdge > 0 ) {

  } else if( DEdge == 2 ) { 
    // R=C=R 
    symbol = "C0";

  } else if( DEdge == 1 ) {

    // 腕が3本  R=C-
 
    int iOxy = atom_count(neighbor_atom , moltmp ,"O");
    int iOedge_2 = 0; // 二重結合しているOxgenを得る
    
    if( iOxy > 0 ) 
      for( int i = 1; i <= neighbor_atom[0][0] ; i ++ )
	if( neighbor_atom[0][i] != -1 ) 
	  if( moltmp.atomsymbol[neighbor_atom[0][i]] == "O" && neighbor_atom[1][i] == 2 ) 
	    iOedge_2 = i;

    if( iOedge_2 > 0 ) { // Oが二重結合していた場合
      if( iOxy == 1 ) {// Oは二重結合のときしか出て来ない場合
	if(iHyd > 2 )
	  symbol = "C0"; // 
	if(iHyd == 2 )
	  symbol = "C2a"; // 
	if(iHyd == 1 ) 
	  symbol = "C4a"; // C5a have only one H
	else  if(iHyd == 0 ) 
	  symbol =  "C5a"; // C5a never have H
      } else if( iOxy == 2 ) { // 重結合 O と 単結合 O を 1つづもっている場合

	//if( iHyd == 1 ) {
	//  symbol = "C4a"; //  C6a and C7a never have H
	// 24 Jul 2008 T.Ohya 　H-C(=O)-O- は"C6a"もしくは"C7a"とするためここの条件は消滅
	//} else {
	  int iOedge_1 = 0;
	  for( int i = 1; i <= 3 ; i ++ )
	    if( neighbor_atom[0][i] != -1 )
	      if( moltmp.atomsymbol[neighbor_atom[0][i]] == "O" && neighbor_atom[1][i] == 1 ) 
		iOedge_1 = i;
	  
	  if( iOedge_1 != 0 ) {
	    
	    if( check_OH( moltmp , cmat , neighbor_atom[0][iOedge_1] , num ) == 1 ) 
	      symbol = "C6a";
	    else
	      symbol = "C7a";
	    
	  } else {
	    cout << "Carbon判定：Oの数と腕の数が一致しない" << endl;
	    exit(1);
	  }
	//}

      } else if( iOxy == 3 && neighbor_atom[0][0] == 3 ) { // 全ての腕に O がついている場合
	int icheckOH = 0;
	for( int i = 1; i <= 3 ; i ++ ) {
	  if( i != iOedge_2 ) {
	    if( neighbor_atom[0][i] != -1 ) {
	      if(  check_OH( moltmp , cmat , neighbor_atom[0][i] , num ) == 1 ) 
	        icheckOH ++;
	    } else {
	      cout << "Carbon判定：Oの数と腕の数が一致しない/Hを含んでいる" << endl;
	      exit(1);
	    }
	  }
	}
	if(icheckOH > 0 ) 
	  symbol = "C6a";
	else
	  symbol = "C7a";
      }
      
    } else {
      
      // 腕は３本だけど =Oを含まない
      if( iHyd == 2 )
	symbol = "C2a";
      else if( iHyd == 1 )
	symbol =  "C2b";
      else if( iHyd == 0 )
	symbol = "C2c";
    }
    
  } else if( neighbor_atom[0][0] == 2 ) {
    // 腕が2本 R=C=R 
    int iOxy = atom_count(neighbor_atom,moltmp ,"O");
 
    if( iOxy == 2 ) // CO2
      symbol = "C0";
    
    else if( ( neighbor_atom[0][1] != -1 && moltmp.atomsymbol[neighbor_atom[0][1]] == "O" && neighbor_atom[1][1] == 2 ) || ( neighbor_atom[0][2] != -1 && moltmp.atomsymbol[neighbor_atom[0][2]] == "O" && neighbor_atom[1][2] == 2 )  ) // O=C=R
      symbol = "C0";
    
    else if( neighbor_atom[1][1] == 2 )
      // R=C=R
      symbol = "C0";
    
    else if( neighbor_atom[1][1] == 3 || neighbor_atom[1][2] == 3 ){
      if( iHyd != 0 )  
	symbol = "C3a";
      else 
	symbol = "C3b";
    }
  } else if( neighbor_atom[0][0] == 1 ) {
    symbol = "C0";
    // 一本鎖
  }

  if( view_neighbor == 1 )
    print_neighbor( neighbor_atom , moltmp );
  matrix_del(neighbor_atom,2);
  return symbol;
}

string classify_C_ring(molform moltmp , int **cmat , int *ring_flg , int num) {
  string symbol;
  symbol = "C0";
  int **neighbor_atom;
  int iEdge = 4;

  if( moltmp.charge[num] >=1 && moltmp.charge[num] <=7 )
    iEdge = iEdge + ( 4 - moltmp.charge[num]);

  neighbor_atom = get_neighboring(moltmp,cmat,num , iEdge);

  int abond = count_neighbor_aroma_bond( neighbor_atom );

  int non_abond = count_neighbor_non_aroma_bond( neighbor_atom );

  if( abond > 1 ) {

    if( int(abond * 1.5) + non_abond > iEdge ) { 
	cout << moltmp.name << " : Aromatic atom (C) :(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
	cout << moltmp.name << " : neighbor atom " ;
	print_neighbor( neighbor_atom , moltmp );
    }
  } else { 

    if( neighbor_atom[1][0] > iEdge ) {
      if( moltmp.ihy == 0 || ( moltmp.ihy == 1 && neighbor_atom[1][0] - iEdge != 1) ) {   
	cout << moltmp.name << " : Edge Count Error (C) Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
	cout << moltmp.name << " : neighbor atom " ;
	print_neighbor( neighbor_atom , moltmp );
	//    exit(1);
      }
    }
  }

  if( moltmp.charge[num] == 5 ) {
    cout << moltmp.name << " : Carbon(-) " << num << " " << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0]  << endl;
    //    cout << moltmp.name << " : neighbor atom " ;
    //    symbol = "C0";
    //    matrix_del(neighbor_atom,2);
    //   return symbol;
  }

  int iHyd = hydrogen_count(neighbor_atom,moltmp);

  if( ring_flg[num] > 1 ) {
    // aromatic ring
    if( iHyd > 0 ) 
      symbol = "C8x";
    else
      symbol = "C8y";
  } else {
    
    if( neighbor_atom[0][0] == 4 ) {
      // 腕が4本 C1a - C1d

      if( iHyd == 2  ) 
	symbol = "C1x";
      else if( iHyd == 1  )  
	symbol = "C1y";
      else if( iHyd == 0  ) 
	symbol = "C1z";

    } else {

      int iOxy = atom_count(neighbor_atom , moltmp ,"O");
      int iOedge_2 = 0; // 二重結合しているOxgenを得る
      int iOedge_3 = 0;

      for( int i = 1; i <= 3 ; i ++ ){
	if( iOxy > 0 ) 
	  if( neighbor_atom[0][i] != -1 )
	    if( moltmp.atomsymbol[neighbor_atom[0][i]] == "O" && neighbor_atom[1][i] == 2 ) 
	      iOedge_2 = i; 
	
	if( neighbor_atom[1][i] == 3 ) {
	  iOedge_3 = i;
	  cout << moltmp.name << " : the Carbon have a triple bond." << num << endl;
	}
      }


      if( iOedge_3 > 0 ) { // Oが二重結合していた場合
	symbol = "C0";  // 服部さんと打ち合せにより例外に決定

      } else if( iOedge_2 > 0 ) { // Oが二重結合していた場合

	if( iOxy == 1 )
	  symbol = "C5x";
	else
	  symbol = "C7x";

      } else {

	if( iHyd == 1 ) 
	  symbol = "C2x";
	else
	  symbol = "C2y";
      }
    }
  }

  if( view_neighbor == 1 )
    print_neighbor( neighbor_atom , moltmp );
  matrix_del(neighbor_atom,2);
  return symbol;
}

string classify_N(molform moltmp , int **cmat , int num) {
  string symbol;
  symbol = "N0";
  int **neighbor_atom;
  int iEdge = 3;

  if( moltmp.charge[num] >=1 && moltmp.charge[num] <=7 )
    iEdge = iEdge + ( 4 - moltmp.charge[num]);
  neighbor_atom = get_neighboring(moltmp,cmat,num , iEdge);
  //  cout << num << endl;
  //  print_neighbor( neighbor_atom , moltmp ); 

  if( neighbor_atom[1][0] > iEdge ) {
    if( moltmp.ihy == 0 || ( moltmp.ihy == 1 && neighbor_atom[1][0] - iEdge != 1) ) {
      cout << moltmp.name << " : Edge Count Error (N) Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
      cout << moltmp.name << " : neighbor atom " ;
      print_neighbor( neighbor_atom , moltmp );    
    }
  }

  if( moltmp.charge[num] == 5 ) {
    cout << moltmp.name << " : Nitrogen(-) " << num << " " << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << endl;
    //    cout << moltmp.name << " : neighbor atom " ;
    //   symbol = "N0";
    //    matrix_del(neighbor_atom,2);
    //    return symbol;
  }

  int iHyd = hydrogen_count(neighbor_atom,moltmp); 

  // Nの分類は、重結合をもっているかで分けている。 
  int NEdge_2 = 0;
  int NEdge_3 = 0;
  for(int i=1; i <= neighbor_atom[0][0]; i++ ){
    if( neighbor_atom[1][i] == 3)
      NEdge_3 = i;
    if( neighbor_atom[1][i] == 2)
      NEdge_2 = i;
  }
  
  if( NEdge_3 != 0 ) {

    if( NEdge_2 != 0 ) 
      symbol = "N0"; 
    else
      symbol = "N3a"; 

  } else if( NEdge_2 != 0 ) {

    if( neighbor_atom[0][0] == 2 && iEdge == 4 ) {
      // R=N^+=R 
      symbol = "N0"; // N2bとして扱うべきか?
      //      cout << "R=N=R" << endl;

      //      cout << neighbor_atom[0][0] << ':' << neighbor_atom[0][1] << endl;
      //      cout << neighbor_atom[1][0] << ':' << neighbor_atom[1][1] << endl;
      
    } else {

      int iHcheck = 0;
      if( moltmp.charge[num] == 3 ) 
	iHcheck ++;

      if( iHyd == 1 + iHcheck ) 
	symbol = "N2a";
      else if( iHyd == 0 + iHcheck )
	symbol = "N2b";
      else if( moltmp.charge[num] == 3 && iHyd == 0 )
	symbol = "N2b"; // (N2c)
    }

  } else { // 重結合をもっていない
    if( neighbor_atom[0][0] == 4 ) {
      // 腕が4本 N1a - N1d
      if( iHyd == 4 )
	symbol = "N0";
      else if( iHyd == 3 ) 
	symbol = "N1a";
      else if( iHyd == 2 ) 
	symbol = "N1b"; 
      else if( iHyd == 1 ) 
	symbol = "N1c";
      else if( iHyd == 0 ) 
	symbol = "N1d";
    } else if( neighbor_atom[0][0] == 3 ) {
      // 腕が３本
      if( iHyd == 3 ) 
	symbol = "N0";
      else if( iHyd == 2 ) 
	symbol = "N1a";
      else if( iHyd == 1 ) 
	symbol = "N1b"; 
      else if( iHyd == 0 ) 
	symbol = "N1c";
    }
  }
  
  if( view_neighbor == 1 )
    print_neighbor( neighbor_atom , moltmp );
  matrix_del(neighbor_atom,2);
  return symbol;
}

string classify_N_ring(molform moltmp , int **cmat , int *ring_flg  , int num) {
  string symbol;
  symbol = "N0";
  int **neighbor_atom;
  int iEdge = 3;

  if( moltmp.charge[num] >=1 && moltmp.charge[num] <=7 )
    iEdge = iEdge + ( 4 - moltmp.charge[num]);
  neighbor_atom = get_neighboring(moltmp,cmat,num , iEdge);
   
  int abond = count_neighbor_aroma_bond( neighbor_atom );
  int non_abond = count_neighbor_non_aroma_bond( neighbor_atom );

  if( abond > 1 ) {

    if( int(abond * 1.5) + non_abond > iEdge ) { 
	cout << moltmp.name << " : Aromatic atom (N):(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
	cout << moltmp.name << " : neighbor atom " ;
	print_neighbor( neighbor_atom , moltmp );
    }
  } else { 

    if( neighbor_atom[1][0] > iEdge ) {
      if( moltmp.ihy == 0 || ( moltmp.ihy == 1 && neighbor_atom[1][0] - iEdge != 1) ) {   
	cout << moltmp.name << " : Edge Count Error (N) Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
	cout << moltmp.name << " : neighbor atom " ;
	print_neighbor( neighbor_atom , moltmp );
	//    exit(1);
      }
    }
  }

  if( moltmp.charge[num] == 5 ) {
    cout << moltmp.name << " : Nitrogen(-) " << num << " " << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0]  << endl;
    //   cout << moltmp.name << " : neighbor atom " ;
    //    symbol = "N0";
    //    matrix_del(neighbor_atom,2); 
    //   return symbol;
  }

  int iHyd = hydrogen_count(neighbor_atom,moltmp); 
  
  
  if( neighbor_atom[0][0] == 4 ) { // N4本腕 なので N0な気がするが・・・
    if( ring_flg[num] == 2 ) 
      symbol = "N5y";
    else
      symbol = "N2y";
  } if( neighbor_atom[0][0] == 3 && moltmp.charge[num] == 3 ) {   
    if( ring_flg[num] == 2 ) 
      symbol = "N5y";
    else
      symbol = "N2y";    
  } else if ( neighbor_atom[0][0] == 2  ) {
     if( ring_flg[num] == 2 ) 
      symbol = "N5x";
    else
      symbol = "N2x";
  } else if ( neighbor_atom[0][0] == 3 ) {
    if( iHyd >= 1 ) {
      if( ring_flg[num] == 2 ) 
	symbol = "N4x";
      else
	symbol = "N1x";
    } else {
      if( ring_flg[num] == 2 ) 
	symbol = "N4y";
      else
	symbol = "N1y";
    }
  }

  if( view_neighbor == 1 )
    print_neighbor( neighbor_atom , moltmp );
  matrix_del(neighbor_atom,2);
  return symbol;
}

string classify_O(molform moltmp , int **cmat , int *ring_flg , int num) {
  string symbol;
  symbol = "O0";
  int **neighbor_atom;
  int iEdge = 2;

  if( moltmp.charge[num] >=1 && moltmp.charge[num] <=7 )
    iEdge = iEdge + ( 4 - moltmp.charge[num]);
  neighbor_atom = get_neighboring(moltmp,cmat,num , iEdge);

  //  cout << "iEdge = " << iEdge << " : charge " << moltmp.charge[num]<< endl;
  //  print_neighbor( neighbor_atom , moltmp );

  if( neighbor_atom[1][0] > iEdge ) {
    if( moltmp.ihy == 0 || ( moltmp.ihy == 1 && neighbor_atom[1][0] - iEdge != 1) ) {
      cout << moltmp.name << " : Edge Count Error (O) Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
      cout << moltmp.name << " : neighbor atom " ;
      print_neighbor( neighbor_atom , moltmp );
      //    exit(1);
    }
  }

  int iHyd = hydrogen_count(neighbor_atom,moltmp); 
  int iP = atom_count(neighbor_atom,moltmp ,"P");
  int iS = atom_count(neighbor_atom,moltmp ,"S");
  int iC = atom_count(neighbor_atom,moltmp ,"C");
  int iN = atom_count(neighbor_atom,moltmp ,"N");
  //  cout << "S= " << iS << endl;
 
  // Cの分類は、重結合をもっているかで分けている。 
  int OEdge_2 = 0;
  for(int i=1; i <= neighbor_atom[0][0]; i++ ){
    if( neighbor_atom[1][i] == 2)
      OEdge_2 = i;
  }
  //  cout << "### " << num << " ### OEdge_2 =" << OEdge_2 <<  endl;

  if( OEdge_2 != 0 ) {

    if( neighbor_atom[0][0] > 1 ) { // 二重結合しているのに、他に隣接原子がある
      symbol = "O0";
      cout << moltmp.name << " : Error (O) R=<O>-R";

    } else {

      if( iC == 1 ) {
	// 二重結合で隣接原子がCの時
 
	int **neighbor_atom_wk;
	int iEdge_wk = 4;

	if( moltmp.charge[  neighbor_atom[0][1] ] >=1 && moltmp.charge[  neighbor_atom[0][1] ] <=7 )
	  iEdge_wk = iEdge_wk + ( 4 - moltmp.charge[num]);
	neighbor_atom_wk = get_neighboring(moltmp,cmat,  neighbor_atom[0][1] , iEdge_wk);

	if( neighbor_atom_wk[0][0] == 2 ) {
	  // <O> = C = R は O0 とする
	  symbol = "O0";

	} else if( ring_flg[ neighbor_atom[0][1] ] > 0 ) {
	  // 隣接Cがリングなら

	  if( atom_count(neighbor_atom_wk,moltmp ,"O") > 1 ) {
	    // 24 Jul 2008 T.Ohya エステル、カルボン酸のカルボニル酸素は"O6a"
	    // symbol = "O7x";
	    symbol = "O6a";
	  } else {
	    symbol = "O5x";
	  }

	} else {

	  int iOwk = 0;
	  iOwk =  atom_count(neighbor_atom_wk,moltmp ,"O");


	  if( hydrogen_count( neighbor_atom_wk,moltmp ) == 2 ) {
	    symbol = "O0";
	  } else if( iOwk > 1 ) {
	    // 24 Jul 2008 T.Ohya エステル、カルボン酸のカルボニル酸素は"O6a"
	    symbol = "O6a";
	    //symbol = "O7a";
	    //	    cout << "O7a(" << num << ")" << endl;
	    //for( int i = 1 ; i <= neighbor_atom_wk[0][0] ; i ++ ) {
	      //	      cout << i << " ";
	    //  if(  neighbor_atom_wk[0][i] != num ) {
		
		// if( check_OH( moltmp , cmat , neighbor_atom_wk[0][i] , neighbor_atom[0][1] ) == 1 ) 
		//  symbol = "O6a";
	    //  }
	    //}
	  } else if( hydrogen_count( neighbor_atom_wk,moltmp ) == 1 ) {
	    // 24 Jul 2008 T.Ohya この条件は"O0"の前にあったものをここに移動
	    symbol = "O4a";
	  } else {
	    symbol = "O5a";
	  }	 
	}
	matrix_del(neighbor_atom_wk,2);

      } else if( iN == 1 )
	symbol = "O3a";
      else if( iP == 1 )
	symbol = "O3b";
      else if( iS == 1 )
	symbol = "O3c";
    }

  } else {
    //            cout << num << "(^^)" << endl;

    if ((moltmp.charge[num] != 5 || iP + iS + iC + iN != 1) && neighbor_atom[0][0] != 2 )  { // 重結合していないのに、Edgeが２本ではない
      // 24 Jul 2008 T.Ohya または負電荷付きでEdgeが1本　ではない
      //            cout << "(^_^)" << neighbor_atom[0][0] << endl;
      symbol = "O0";

    } else {

      // 隣接炭素が二重結合酸素を持っているか
      if( iC == 2 ) {

	int iOflg = 0;

	for( int k = 1; k <= 2 ; k ++ ) {
	  int **neighbor_atom_wk;
	  int iEdge_wk = 4;
	  int iCnum = neighbor_atom[0][k];

	  if( moltmp.charge[ iCnum ] >=1 && moltmp.charge[ iCnum ] <=7 )
	    iEdge_wk = iEdge_wk + ( 4 - moltmp.charge[num]);
	  neighbor_atom_wk = get_neighboring(moltmp,cmat,  iCnum , iEdge_wk);
	  for( int i = 1 ; i <= neighbor_atom_wk[0][0] ; i ++ )
	    if( neighbor_atom_wk[0][i] != -1 && 
            moltmp.atomsymbol[neighbor_atom_wk[0][i]] == "O" && 
            neighbor_atom_wk[1][i] == 2 ) {
	      if( hydrogen_count( neighbor_atom_wk,moltmp ) == 0 )
            iOflg = 1;
	    }
	  matrix_del(neighbor_atom_wk,2);
	}
	
	if( iOflg >= 1 ) {
	  // O=C-<O>-?
	  if( iHyd == 1 ){
	    symbol = "O6a";
      }
	  else{
	    symbol = "O7a";
      }
    }
	else
	  symbol = "O2a";

      } else if ( iC == 1 ) { 
	//	int CEdge = 0;
	int iCnum;
	if( neighbor_atom[0][1] != -1 &&  
        moltmp.atomsymbol[neighbor_atom[0][1]] == "C" ) {
	  iCnum = neighbor_atom[0][1];
    }
	else 
    {
	  iCnum = neighbor_atom[0][2];
    }

	int **neighbor_atom_wk;
	int iEdge_wk = 4;
	int iOflg = 0;
	if( moltmp.charge[  iCnum ] >=1 && moltmp.charge[ iCnum ] <=7 )
	  iEdge_wk = iEdge_wk + ( 4 - moltmp.charge[num]);
	neighbor_atom_wk = get_neighboring(moltmp,cmat,  iCnum , iEdge_wk);
	for( int i = 1 ; i <= neighbor_atom_wk[0][0] ; i ++ ){
	  if( neighbor_atom_wk[0][i] != -1 && 
          moltmp.atomsymbol[neighbor_atom_wk[0][i]] == "O" && 
          neighbor_atom_wk[1][i] == 2 ){
	    if( hydrogen_count( neighbor_atom_wk,moltmp ) == 0 )
	      iOflg = 1;
      }
    }
	matrix_del(neighbor_atom_wk,2);

	if( iOflg == 1 ) 
	  if( iHyd == 1 ) 
	    symbol = "O6a";
	  else
	    symbol = "O7a";
	else
	  if( iHyd == 1 )
	    // C-O-H  i.e. R-O-H
	    symbol = "O1a";
	  else if( iP == 1 )
	    // C-O-P  i.e. R-O-P
	    symbol = "O2b";
	  else if( moltmp.charge[num] == 5 )
	  // 24 Jul 2008 T.Ohya 上で[O-]は除外されないから
	    symbol = "O0";
	  else
	    // C-O-? i.e. R-O-R
	    symbol = "O2a";

      } else { // 二重結合で炭素無し

	if( iHyd == 2 ) 
	  // H-O-H
	  symbol == "O0";
	else if( iP == 2 )
	  // P-O-P
	  symbol = "O2c";
	else if( iP == 1) {
	  // 燐原子の電荷を取得する　24 Jul 2008 T.Ohya
	  int iPnum;
	  if( neighbor_atom[0][1] != -1 &&  moltmp.atomsymbol[neighbor_atom[0][1]] == "P" ) 
	    iPnum = neighbor_atom[0][1];
	  else
	    iPnum = neighbor_atom[0][2];

	  if (moltmp.charge[num] == 5){
	    if (moltmp.charge[ iPnum ] > 0 && moltmp.charge[ iPnum ] < 4)
	    // [P+]-[O-] => P=O とみなす　24 Jul 2008 T.Ohya
	      symbol = "O3b";
	    else
	    // P-[O-] => P-OH とみなす　24 Jul 2008 T.Ohya
	      symbol = "O1c";
	  } else if( iHyd == 1)
	    // P-O-H
	    symbol = "O1c";
	  else
	    // P-O-R
	    symbol = "O2b";

	} else if( iS == 1 ) {
	  // 硫黄原子の電荷を取得する　24 Jul 2008 T.Ohya
	  int iSnum;
	  if( neighbor_atom[0][1] != -1 &&  moltmp.atomsymbol[neighbor_atom[0][1]] == "S" ) 
	    iSnum = neighbor_atom[0][1];
	  else
	    iSnum = neighbor_atom[0][2];

	  if (moltmp.charge[num] == 5){
	    if (moltmp.charge[ iSnum ] > 0 && moltmp.charge[ iSnum ] < 4)
	      // [S+]-[O-] => S=O とみなす　24 Jul 2008 T.Ohya
	      symbol = "O3c";
	    else
	      // S-[O-] => S-OH とみなす　24 Jul 2008 T.Ohya
	      symbol = "O1d";
	  } else if( iHyd == 1 )
	      // S-O-H
	      symbol = "O1d";
	  else
	    symbol = "O2a";
	} else if( iN == 1 ) {
	  // 窒素原子の電荷を取得する　24 Jul 2008 T.Ohya
	  int iNnum;
	  if( neighbor_atom[0][1] != -1 &&  moltmp.atomsymbol[neighbor_atom[0][1]] == "N" ) 
	    iNnum = neighbor_atom[0][1];
	  else
	    iNnum = neighbor_atom[0][2];

	  if (moltmp.charge[num] == 5){
	    if (moltmp.charge[ iNnum ] > 0 && moltmp.charge[ iNnum ] < 4)
	      // [N+]-[O-] => N=O とみなす　24 Jul 2008 T.Ohya
	      symbol = "O3a";
	    else
	      // N-[O-] => N-OH とみなす　24 Jul 2008 T.Ohya
	      symbol = "O1b";
	  } else if( iHyd == 1 )
	    symbol = "O1b";
	  else
	    symbol = "O2a";
	} else if( iHyd == 1 )
	  symbol = "O1a";
	else
	  symbol = "O2a";
      }
    }
  }

  if( view_neighbor == 1 )
    print_neighbor( neighbor_atom , moltmp );
  matrix_del(neighbor_atom,2);
  return symbol;
}


string classify_O_ring(molform moltmp , int **cmat , int *ring_flg , int num) {
  string symbol;
  symbol = "O0";
  int **neighbor_atom;
  int iEdge = 2;

  if( moltmp.charge[num] >=1 && moltmp.charge[num] <=7 )
    iEdge = iEdge + ( 4 - moltmp.charge[num]);
  neighbor_atom = get_neighboring(moltmp,cmat,num , iEdge);
   
  int abond = count_neighbor_aroma_bond( neighbor_atom );
  int non_abond = count_neighbor_non_aroma_bond( neighbor_atom );

  if( abond > 1 ) {

    if( abond + non_abond > iEdge ) { 
	cout << moltmp.name << " : Aromatic atom (O) :(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
	cout << moltmp.name << " : neighbor atom " ;
	print_neighbor( neighbor_atom , moltmp );
    }
  } else { 

    if( neighbor_atom[1][0] > iEdge ) {
      if( moltmp.ihy == 0 || ( moltmp.ihy == 1 && neighbor_atom[1][0] - iEdge != 1) ) {
	cout << moltmp.name << " : Edge Count Error (O) Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
	cout << moltmp.name << " : neighbor atom " ;
	print_neighbor( neighbor_atom , moltmp );
	//    exit(1);
      }
    }
  }

  // ringなのでとりあえず O2x とする。

  symbol = "O2x";

  int iC = atom_count(neighbor_atom,moltmp ,"C");
  
  // 隣接炭素が二重結合酸素を持っているか

  if( iC > 0 ) {

    int iOflg = 0;
    for( int k = 1; k <= neighbor_atom[0][0] ; k ++ ) {

      if( neighbor_atom[0][k] != -1 && moltmp.atomsymbol[neighbor_atom[0][k]] == "C" ) {
	
	int **neighbor_atom_wk;
	int iEdge_wk = 4;
	int iCnum = neighbor_atom[0][k];

	if( moltmp.charge[ iCnum ] >=1 && moltmp.charge[ iCnum ] <=7 )
	  iEdge_wk = iEdge_wk + ( 4 - moltmp.charge[num]);
	neighbor_atom_wk = get_neighboring(moltmp,cmat,  iCnum , iEdge_wk);

	for( int i = 1 ; i <= neighbor_atom_wk[0][0] ; i ++ )
	  if( neighbor_atom_wk[0][i] != -1 && moltmp.atomsymbol[neighbor_atom_wk[0][i]] == "O" && neighbor_atom_wk[1][i] == 2 &&  neighbor_atom_wk[0][i] != num) 
	    iOflg ++;

	//	print_neighbor( neighbor_atom_wk , moltmp );

	matrix_del(neighbor_atom_wk,2);
      }
    }
    
    if( iOflg >= 1 ) {
      // O=C-<O>-C
      symbol = "O7x";
      //      cout << "(!_!)" << iOflg << endl;
    }
  }

  if( view_neighbor == 1 )
    print_neighbor( neighbor_atom , moltmp );
  matrix_del(neighbor_atom,2);
  return symbol;
}

string classify_S(molform moltmp , int **cmat , int *ring_flg , int num) {

  string symbol;
  symbol = "S0";
  int **neighbor_atom;
  int iEdge = 2;

  if( moltmp.valence[num] == 15 ) 
    return symbol;

  if( moltmp.charge[num] >=1 && moltmp.charge[num] <=7 )
    iEdge = iEdge + ( 4 - moltmp.charge[num]);
  neighbor_atom = get_neighboring(moltmp,cmat,num , iEdge);

  if( neighbor_atom[1][0] > iEdge ) {
    int iEdgeWk = 6  + ( 4 - moltmp.charge[num]);
    if( iEdgeWk == neighbor_atom[1][0] ) {
      cout << moltmp.name << " : Edge Count Error (S-6) Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
      cout << moltmp.name << " : neighbor atom " ;
      print_neighbor( neighbor_atom , moltmp );

    } else if( iEdgeWk == neighbor_atom[1][0] ) { 

      cout << moltmp.name << " : Edge Count Error (S) Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
      cout << moltmp.name << " : neighbor atom " ;
      print_neighbor( neighbor_atom , moltmp );
      //    exit(1);
    }
  }

  if( iEdge == 2 && neighbor_atom[0][0] == 1 ) {
    // S = R
    matrix_del(neighbor_atom,2);
    return symbol;
  }


  if( ring_flg[num] != 0 ) {
    int iS = atom_count(neighbor_atom,moltmp ,"S");
    if( iS > 0 )
      symbol = "S3x";
    else
      symbol = "S2x";    
    
  } else {

    if( atom_count(neighbor_atom,moltmp ,"O") > 0 ) {

      symbol = "S4a"; 

    } else if ( neighbor_atom[1][0] == 2 ) {
    
      int iHyd = hydrogen_count(neighbor_atom,moltmp); 
      int iS = atom_count(neighbor_atom,moltmp ,"S");

      if( iS > 0 ) {
	if ( iHyd > 0 )
	  symbol = "S1a"; // S-<S>-H i.e. R-S-H
	else {

	  int iSHflg = 0;
	  for( int i = 1 ; i <= neighbor_atom[0][0] ; i ++ ){
	    if( neighbor_atom[0][i] != -1 && moltmp.atomsymbol[neighbor_atom[0][i]] == "S" ) {
	      int **neighbor_atom_wk;
	      int iEdge_wk = 2;
	      int iSnum = neighbor_atom[0][i];

	      if( moltmp.charge[ iSnum ] >=1 && moltmp.charge[ iSnum ] <=7 )
		iEdge_wk = iEdge_wk + ( 4 - moltmp.charge[num]);
	      neighbor_atom_wk = get_neighboring(moltmp,cmat,  iSnum , iEdge_wk);

	      for( int j = 1 ; j <= neighbor_atom_wk[0][0] ; j ++ )
		if( neighbor_atom_wk[0][i] == -1 || moltmp.atomsymbol[neighbor_atom_wk[0][i]] == "H" ) 
		  iSHflg ++;

	      matrix_del(neighbor_atom_wk,2);

	    }
	  }

	  if( iSHflg > 0 ) 
	    symbol = "S2a"; // H-S-<S>-R i.e. R-S-R
	  else
	    symbol = "S3a"; // R-S-<S>-R
	}
      } else if ( iHyd > 1 ) {
	symbol = "S0"; // H-S-H
      } else if ( iHyd == 1 ) {
	symbol = "S1a";
      } else {
	symbol = "S2a";
      }
    } else {
      symbol = "S0";
    }
  }
      
  if( view_neighbor == 1 )
    print_neighbor( neighbor_atom , moltmp );
  matrix_del(neighbor_atom,2);
  return symbol;
  
}

string classify_P(molform moltmp , int **cmat , int num) {

  string symbol;
  symbol = "P0";
  int **neighbor_atom;
  int iEdge = 1;

  if( moltmp.charge[num] >=1 && moltmp.charge[num] <=7 )
    iEdge = iEdge + ( 4 - moltmp.charge[num]);
  neighbor_atom = get_neighboring(moltmp,cmat,num , iEdge);

  if( neighbor_atom[1][0] > iEdge ) {
    int iEdgeWk = 5  + ( 4 - moltmp.charge[num]);
    if( iEdgeWk == neighbor_atom[1][0] ) {
      cout << moltmp.name << " : Edge Count Error (P-5) Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
      cout << moltmp.name << " : neighbor atom " ;
      print_neighbor( neighbor_atom , moltmp );

    } else if( iEdgeWk == neighbor_atom[1][0] ) { 

      cout << moltmp.name << " : Edge Count Error (P) Charge:(" << moltmp.charge[num] << "/" << iEdge << ":" << neighbor_atom[1][0] << ")"  << endl;
      cout << moltmp.name << " : neighbor atom " ;
      print_neighbor( neighbor_atom , moltmp );
      //    exit(1);
    }
  }

  int OEdge_2 = 0;
  for( int k = 1; k <= neighbor_atom[0][0] ; k ++ ) {
    if( neighbor_atom[0][k] != -1 && moltmp.atomsymbol[neighbor_atom[0][k]] == "O" && neighbor_atom[1][k] == 2 ) {
      OEdge_2 = k;
    }
  }

  if( OEdge_2 > 0 ) {
    if( atom_count(neighbor_atom,moltmp ,"O") > 2 ) 
      symbol = "P1b";
    else
      symbol = "P1a";
  } else {
    symbol = "P1a";
  }

  //  if( neighbor_atom[0][0] == 0 )
  //    symbol = "P0";
  //  else {
  //   int iO = atom_count(neighbor_atom,moltmp ,"O");
  //   if( iO > 0 )
  //     symbol = "P1b";
  //  else
  //    symbol = "P1a";          
  // }

  if( view_neighbor == 1 )
    print_neighbor( neighbor_atom , moltmp );
  matrix_del(neighbor_atom,2);
  return symbol;
  
}

// 20091027 start 
void ModifyKcfSymbol(molform *mol, int **cmat_b)
{
  int iO1aFlg = -1;
  int iO6aFlg = -1;

  for(int ii=0; ii < mol->nodenum; ii++){
    //
    // modify for formic acid
    //
    if(mol->kcfsymbol[ii] == "C6a"){
      for(int jj=0; jj < mol->nodenum; jj++){
        if(cmat_b[ii][jj] != 0){
          if(mol->kcfsymbol[jj] == "O6a") iO6aFlg = jj;
          else if(mol->kcfsymbol[jj] == "O1a") iO1aFlg = jj;
        }
      }
      if(iO6aFlg > -1 && iO1aFlg > -1){
        mol->kcfsymbol[iO1aFlg] = "O6a";
      }
    }
    //
    // modify for phosphate
    //
    else if(mol->kcfsymbol[ii] == "P1b"){
      for(int jj=0; jj < mol->nodenum; jj++){
        if(cmat_b[ii][jj] != 0){
          if(mol->kcfsymbol[jj] == "O1c"){
            for(int kk=0; kk < mol->nodenum; kk++){
              if(jj == kk) continue;
              if(mol->kcfsymbol[kk] == "O3b") mol->kcfsymbol[kk] = "O1c";
            }
            break;
          }
        }
      }
    }
    //
    // modify for sulphate
    //
    else if(mol->kcfsymbol[ii] == "S4a"){
      for(int jj=0; jj < mol->nodenum; jj++){
        if(cmat_b[ii][jj] != 0){
          if(mol->kcfsymbol[jj] == "O1d"){
            for(int kk=0; kk < mol->nodenum; kk++){
              if(jj == kk) continue;
              if(mol->kcfsymbol[kk] == "O3c") mol->kcfsymbol[kk] = "O1d";
            }
            break;
          }
        }
      }
    }
  }
}
// end

//-----------------------------------------------------------------
