// cpdformat.h
//
// 7 Juli 2004 K.Tonomura
//

#ifndef __READMOL_H
#define __READMOL_H
#define STRING_SIZE 999

#include <stdio.h>
#include <string.h>
#include<iostream>
#include<fstream>
#include "t_string.h"
#include "t_matrix.h"

using namespace std;

typedef struct _bonds {
  int s[STRING_SIZE],e[STRING_SIZE];
  int bondtype[STRING_SIZE];
  int stereo[STRING_SIZE];
  int ring[STRING_SIZE];
}bonds;

typedef struct _pathlist {
  int count;
  int **list;
}pathlist;

typedef struct _cpathlist {

  int i_count;
  int **i_status;

  int count;
  int **list;
}cpathlist;


typedef struct _molform {
  char *name;  
  char *oname;
  char *definition;
  int nodenum; /* total number of node */
  int bondnum; /* total number of bond */
  int chiral;
  
  int massdifference[STRING_SIZE];
  int charge[STRING_SIZE];
  int stereoparity[STRING_SIZE];
  int hydrogencount[STRING_SIZE];
  int stereocare[STRING_SIZE];
  int valence[STRING_SIZE];
  int index[STRING_SIZE];

  //  int matrix[][];
  double x[STRING_SIZE],y[STRING_SIZE],z[STRING_SIZE];
  bonds bond;
  string atomsymbol[STRING_SIZE];
  string kcfsymbol[STRING_SIZE];

  // option of calcuration 
  int ihy;

}molform;

typedef struct _line {
  double x1,y1,x2,y2;
  bool set;
}line;

typedef struct _bracket {
  int count;
  string type;
  string uopt;
  string dopt;
  line l1;
  line l2;
  int rep_atom_num;
  int rep_atom[512];
  int org_atom_num;
  int org_atom[512];
} bracket;

typedef struct _brackets {
  int member;
  bracket br[20];
} brackets;


molform read_Molfile(FILE * , bool );
molform read_Kcffile(FILE * , bool );

brackets read_Bracket(FILE *);
// void read_Braket(FILE *);

void output_kcffile(molform, brackets ,char * , bool , bool);
void output_Molfile(molform, char * );
void output_mol_aromaticity(char *, char *, int *);
bool check_aromabond(molform);
int check_aromanode(molform , int );

// void  set_cmatrix(int **, molform);

#endif
