// kcfvector.c
//
// 18 Feb 2004 K.Tonomura
//

#include "kcfvector.h"

kcflist SetKcfList (int type){

  kcflist klist;
  klist.num_c = KCF_C;
  string wk_c [KCF_C] =  { "C1a","C1b","C1c","C1d", 
			   "C2a","C2b","C2c",
			   "C3a","C3b","C4a","C5a",
			   "C6a","C7a",
			   "C1x","C1y","C1z",
			   "C2x","C2y",
			   "C5x","C7x","C8x","C8y",
			   "C0" };  
  klist.num_n = KCF_N;
  string wk_n [KCF_N] =  { "N1a","N1b","N1c","N1d", 
			   "N2a","N2b","N3a",
			   "N1x","N1y","N2x","N2y",
			   "N4x","N4y","N5x","N5y",
			   "N0" };
  klist.num_o = KCF_O;
  string wk_o [KCF_O] =  { "O1a","O1b","O1c","O1d", 
			   "O2a","O2b","O2c",
			   "O3a","O3b","O3c",
			   "O4a","O5a","O6a","O7a",
			   "O2x","O5x","O7x",
			   "O0" };
  klist.num_s = KCF_S;
  string wk_s [KCF_S] =  { "S1a","S2a","S2x","S3a","S3x","S4a",
			   "S0" };
  klist.num_p = KCF_P;
  string wk_p [KCF_P] =  { "P1a","P1b",
			   "P0" };
  klist.num_x = KCF_X;
  string wk_x [KCF_X] =  { "F","Cl","Br","I","At"};


  for( int i = 0 ; i < klist.num_c ; i ++ ) { 
    klist.member_c[i] = wk_c[i];
  }
  for( int i = 0 ; i < klist.num_n ; i ++ ) { 
    klist.member_n[i] = wk_n[i];
  }
  for( int i = 0 ; i < klist.num_o ; i ++ ) { 
    klist.member_o[i] = wk_o[i];
  }
  for( int i = 0 ; i < klist.num_s ; i ++ ) { 
    klist.member_s[i] = wk_s[i];
  }
  for( int i = 0 ; i < klist.num_p ; i ++ ) { 
    klist.member_p[i] = wk_p[i];
  }
  for( int i = 0 ; i < klist.num_x ; i ++ ) { 
    klist.member_x[i] = wk_x[i];
  }
  //  cout << "(^^)" << endl;
  return klist;
  
}

void print_Klist(kcflist klist) {

  cout << "C = ";
  for( int i = 0 ; i < klist.num_c ; i ++ ) { 
        cout <<  klist.member_c[i] << " ";
  }
  cout << endl;
  cout << "N = ";
  for( int i = 0 ; i < klist.num_n ; i ++ ) { 
        cout <<  klist.member_n[i] << " ";
  }
  cout << endl;
  cout << "O = ";
  for( int i = 0 ; i < klist.num_o ; i ++ ) { 
        cout <<  klist.member_o[i] << " ";
  }
  cout << endl;
  cout << "S = ";
  for( int i = 0 ; i < klist.num_s ; i ++ ) { 
        cout <<  klist.member_s[i] << " ";
  }
  cout << endl;
  cout << "P = ";
  for( int i = 0 ; i < klist.num_p ; i ++ ) { 
        cout <<  klist.member_p[i] << " ";
  }
  cout << endl;
  cout << "Halogens = ";
  for( int i = 0 ; i < klist.num_x ; i ++ ) { 
        cout <<  klist.member_x[i] << " ";
  }
  cout << endl;
}

int *SetKcfVector(int *vector, string kcfsymbol, string atomsymbol,kcflist klist , int itype){
  int anum = 0;
  if( atomsymbol == "C" ) {
    anum = 0;
    for( int i = 0 ; i < klist.num_c ; i ++ ) { 
      if( kcfsymbol == klist.member_c[i] )
	anum = i;
    }
    if( anum == 0 ) 
      anum = klist.num_c - 1;

  } else if( atomsymbol == "N" ) {
    anum = 0;
    for( int i = 0 ; i < klist.num_n ; i ++ ) { 
      if( kcfsymbol == klist.member_n[i] )
	anum = klist.num_c + i;
    }
    if( anum == 0 ) 
      anum = klist.num_c + klist.num_n - 1;

  } else if( atomsymbol == "O" ) {
    anum = 0;
    for( int i = 0 ; i < klist.num_o ; i ++ ) { 
      if( kcfsymbol == klist.member_o[i] )
	anum = klist.num_c + klist.num_n + i;
    }
    if( anum == 0 ) 
      anum = klist.num_c + klist.num_n + klist.num_o - 1;

  } else if( atomsymbol == "S"  ) {
    anum = 0;
    for( int i = 0 ; i < klist.num_s ; i ++ ) { 
      if( kcfsymbol == klist.member_s[i] )
	anum = klist.num_c + klist.num_n + klist.num_o + i;
    }
    if( anum == 0 ) 
      anum = klist.num_c + klist.num_n + klist.num_o + klist.num_s - 1;

  } else if( atomsymbol == "P" ) {
    anum = 0;
    for( int i = 0 ; i < klist.num_p ; i ++ ) { 
      if( kcfsymbol == klist.member_p[i] )
	anum = klist.num_c + klist.num_n + klist.num_o + klist.num_s + i;
    }
    if( anum == 0 ) 
      anum = klist.num_c + klist.num_n + klist.num_o + klist.num_s + klist.num_p - 1;

  } else {

    if( itype == 2 ) {
      if(  atomsymbol == "X"  ) {

	anum = 0;
	for( int i = 0 ; i < klist.num_x ; i ++ ) { 
	  if( kcfsymbol == klist.member_x[i] )
	    anum = klist.num_c + klist.num_n + klist.num_o + klist.num_s + klist.num_p + i;
	}
	if( anum == 0 ) 
	  anum = klist.num_c + klist.num_n + klist.num_o + klist.num_s + klist.num_p + klist.num_x - 1;
      } else {
	anum = klist.num_c + klist.num_n + klist.num_o + klist.num_s + klist.num_p + klist.num_x;
      }
    } else if( itype == 1 ) {
       if(  atomsymbol == "X" ) {
	anum = 0;
	anum = klist.num_c + klist.num_n + klist.num_o + klist.num_s + klist.num_p;
       } else {
	anum = klist.num_c + klist.num_n + klist.num_o + klist.num_s + klist.num_p + 1 ;
	//	cout << "anum = " << anum << endl;
       }
    } 
  }
  
  vector[anum] ++;
  return vector;
}

void print_KcfVector(int *vector, kcflist klist , int itype){

  int ikcfmem = klist.num_c + klist.num_n + klist.num_o + klist.num_s + klist.num_p;
  int i;

  //  cout << " voption = " << itype;

  cout << "Carbon     : ";
  for( i = 0 ; i < ikcfmem ; i ++ ) {
    if( i ==  klist.num_c )
      cout << endl << "Nitrogen   : " ;
    else  if( i ==  klist.num_c + klist.num_n )
      cout << endl << "Oxygen     : " ;
    else  if( i ==  klist.num_c + klist.num_n + klist.num_o )
      cout << endl << "Sulfur     : " ;
    else  if( i ==  klist.num_c + klist.num_n + klist.num_o + klist.num_s )
      cout << endl << "Phosphorus : " ;
    cout << vector[i] << " ";
  }

  if( itype == 2 ) {
    cout << endl << "Halogens   : ";
    for( i = 0 ; i < klist.num_x ; i ++ )
      cout << vector[ikcfmem + i] << " ";
    cout << endl << "Others     : " << vector[ikcfmem + klist.num_x ] << endl;
  } else {
    cout << endl << "Others     : " << vector[ikcfmem ] << " " << vector[ikcfmem + 1 ] << endl;
  }


}

void print_KcfVector_line(int *vector, int dim, string name) {
  cout << name << "=" << vector[0] ;
  for(int i = 1 ; i < dim ; i ++ ) 
    cout << ',' << vector[i];
  cout << endl;
}

void output_KcfVector_line(int *vector, int dim, string name, char *sFile ) {
  ofstream fout(sFile);
  fout << name << "=" << vector[0] ;
  for(int i = 1 ; i < dim ; i ++ ) 
    fout << ',' << vector[i];
  fout << endl;
  fout.close();
}
