// t_graphtool.c
//
// 24 August 2004 K.Tonomura
//


#include "t_graphtool.h"

/*
void  set_cmatrix(int **a, molform moltmp){
  if( moltmp.bondnum > 0) {
    for(int i=0; i< moltmp.bondnum ; i++ ){
      //  printf("%d %d\n",j,k);
      a[moltmp.bond.s[i] - 1 ][moltmp.bond.e[i] - 1 ] = 1;
      a[moltmp.bond.e[i] - 1 ][moltmp.bond.s[i] - 1 ] = 1;
    }
  } 
}
*/

int checkmetal(string atom) {
  int ret = 0;
  if( atom == "*" || atom == "Fe" || atom == "Co" || atom == "Mg" ) {
    ret = 1;
    //    cout << "metal!" << endl;
  }
  return ret;
}


void  set_cmatrix(int **a, molform moltmp, int bflg, int non_metalflg){
  int btype;
  if( moltmp.bondnum > 0) {
    for(int i=0; i< moltmp.bondnum ; i++ ){
      btype = 1;
      
      if( bflg != 1 ) {
	//	if( moltmp.bond.bondtype[i] < 4 && moltmp.bond.bondtype[i] > 0 ) {

	if( moltmp.bond.bondtype[i] <= 4 && moltmp.bond.bondtype[i] > 0 ) {
	  btype = moltmp.bond.bondtype[i];
	} else  if( moltmp.bond.bondtype[i] == 0 ) {
	  btype = 0;
	} else {
	  btype = 0;
	}
      }
      
      //      cout << moltmp.atomsymbol[moltmp.bond.s[i] - 1] << '-'  << moltmp.atomsymbol[moltmp.bond.e[i] -1 ] << endl;;

      if( (checkmetal(moltmp.atomsymbol[moltmp.bond.s[i] -1 ]) != 1 && checkmetal(moltmp.atomsymbol[moltmp.bond.e[i] -1 ]) != 1 ) || non_metalflg != 1 ) {

	a[moltmp.bond.s[i] - 1 ][moltmp.bond.e[i] - 1 ] = btype;
	a[moltmp.bond.e[i] - 1 ][moltmp.bond.s[i] - 1 ] = btype;

      } else {
	//		cout << "Mcancel" << endl;
      }
    }
  } 
}

int count_edges(int **a, int dim) {
  int count = 0;
  for(int i=0; i < dim; i ++ ) {
    for(int j=i; j < dim; j ++ ) {
      if( i != j ) {
	if( a[i][j] > 0 )
	  count ++;
      }
    }  
  }
  return count;
}

int **set_cpair(int **a, int dim) {
  int count = 0;
  count = count_edges(a , dim);
  int **b;
  b = matrix_new(count,2);
  count = 0;
  for(int i=0; i < dim; i ++ ) {
    for(int j=i; j < dim; j ++ ) {
      if( i != j ) {
	if( a[i][j] > 0 ) {
	  b[count][0] = i;
	  b[count][1] = j;
	  count ++;
	}
      }
    }  
  }
  return b;
}

int *set_edge_index(molform moltmp , int **cpair , int edges) {
  int *b = new int [moltmp.bondnum];;
  for(int i=0; i < moltmp.bondnum ; i ++ ) {
    //    cout << i << " " <<  moltmp.bond.s[i] - 1 << "-" <<  moltmp.bond.e[i] - 1 << endl;
    b[i] = -1;
  }

  for(int i=0; i < edges ; i ++ ) {
    //    cout << i << " cpair " << cpair[i][0] << " " << cpair[i][1] << endl;
    for(int j=0; j < moltmp.bondnum ; j ++ ) {
      //            cout << i << " " << j << endl; 
      if( cpair[i][0] == moltmp.bond.s[j] - 1 && cpair[i][1] == moltmp.bond.e[j] - 1 ) {
	b[j] = i;
      } else if(  cpair[i][0] == moltmp.bond.e[j] - 1 && cpair[i][1] == moltmp.bond.s[j] - 1 ) {
	b[j] = i;
      }
    }
  }
  return b;
}

int move_index(int i, int *index , int dim , int inverse) {

  if( i > dim ) {
    return -1;
  } 

  if( inverse == -1 ) {
    for( int j = 0 ; j < dim ; j ++ ) {
      if( index[j] == i ) {
	return j;
      }
    }

  } else {
    return index[i];
  }
  return -1;

}

// compute isolated node
int check_isolatednode(int **a, int dim) {
  int i,j,line,count;
  count = 0;
  for(i=0; i < dim ; i++ ) {
    line = 0;
    for(j = 0; j < dim ; j++) {
      if( i != j) {line += a[i][j]; }
    }
    if(line == 0 ) { count ++ ; }
  }
  return count;
}

// delete isolated node
void matrix_delete_isolatednode(int **a,int dim ){
  int i,j,line;
  if( check_isolatednode( a , dim ) != 0 ) {

    for(i=0; i< dim ; i ++ ) {
      line = 0;
      for(j = 0; j < dim ; j ++) {
	if( i != j) {line += a[i][j]; }
      }
      if( line == 0 ) {
	for(j = 0; j < dim ; j ++) {
	  if( i != j) { a[i][j] = 0; a[j][i] = 0;}
	}
      }
    }
    if( check_isolatednode(a , dim ) != 0 ) {
      matrix_delete_isolatednode(a, dim);
    }
  }
}

// compute terminal node
int check_terminalnode(int **a, int dim) {
  int i,j,line,count;
  count = 0;
  for(i=0; i < dim ; i++ ) {
    line = 0;
    for(j = 0; j < dim ; j++) {
      if( i != j) {line += a[i][j]; }
    }
    if(line == 1 ) { count ++ ; }
  }
  return count;
}

// delete terminal node
void matrix_delete_terminalnode(int **a,int dim ){
  int i,j,line;
  if( check_terminalnode( a , dim ) != 0 ) {

    for(i=0; i< dim ; i ++ ) {
      line = 0;
      for(j = 0; j < dim ; j ++) {
	if( i != j) {line += a[i][j]; }
      }
      if( line == 1 ) {
	for(j = 0; j < dim ; j ++) {
	  if( i != j) { a[i][j] = 0; a[j][i] = 0;}
	}
      }
    }
    if( check_terminalnode(a , dim ) != 0 ) {
      matrix_delete_terminalnode(a, dim);
    }

  }
}

// compute edges
int count_edge(int point, int **a, int dim) {
  int i,count;
  count = 0;
  for(i = 0; i < dim ; i++) {
    if( i != point) {
      if(a[i][point] != 0 )
	count ++;
    }
  }
  return count;
}


// search hub-node(>2) 
// when flg = 0 , return not hub points 
int **search_hubnode(int **mat, int dim, int flg) {
  int i,j,line,count,edges; 
  int **hub;
  hub = matrix_new(2,dim+1);
 
  for(i = 0; i <= dim ; i++ ) {
    hub[0][i] = 0;
    hub[1][i] = 0;
  }
  count = 0;
  edges = 0;
  for(i = 0; i < dim ; i++ ) {
    line = 0;
    for(j = 0; j < dim ; j++) {
      if( i != j) {
	if( mat[i][j] > 0 ) { 
	  line ++; 
	  //	  	  cout << " mat[" << i << "][" << j << "]:" << mat[i][j] << " line:" << line << endl;
	}
      }
    }
    if(flg != 0 ) {
      if(line > 2 ) { 
	count ++ ;
	hub[0][count] = i;
	hub[1][count] = line;
	edges += line;
	//	cout << " SET: " << count << ":" << i << "/" << line << endl;
      }
    } else {
      if(line < 2 ) {
	count ++ ;
	hub[0][count] = i;
	hub[1][count] = line;
      }
    }
    //    printf("node %d : Hub %d\n",i,line);
  }
  //  printf("result of node %d : edges %d\n",count,edges);
  hub[0][0] = count;
  hub[1][0] = edges;
  return hub;
}

// treeリストにnodeが含まれているかどうか判定する。
// 0文字目はノード数
int grep_node(int node, int *tree ) {
  for(int i = 1; i<=tree[0] ; i ++ ) {
    if( node == tree[i] ) { 
      return 1;
    }
  }
  return 0;
}

// nodeを若い順に並べ換える。
// 0文字目はノード数
void sort_node(int *nodes ) {
  for(int i = 1; i<=nodes[0] ; i ++ ) {
    for(int j = i+1; j<=nodes[0] ; j ++ ) {
      if( nodes[i] > nodes[j]) {
	int work;
	work = nodes[i];
	nodes[i] = nodes[j];
	nodes[j] = work;
      }
    }
  }
}

// node を 若い順に並べ換える。
// 0文字目はノード数

void normalyse_node(int *nodes ) {

  if( nodes[0] > 1 ) {

    int index_m = 1;
    for(int i=2 ; i<= nodes[0] ; i++ ) {
      if( nodes[i] < nodes[index_m] ) {
	index_m = i;
      }
    }
    //    cout << "index_m=" << index_m << ":" << nodes[index_m] << endl;

    if( index_m > 1 ) {
      int *wk;
      wk = index_copy( nodes , nodes[0] + 1 );
      for(int i = index_m ; i <= nodes[0] ; i++ ) {
	//	cout << i << "(" << i - index_m + 1 << ")";
	nodes[i - index_m + 1] = wk[i];
      }
      //      cout << "|" ;
      for(int i = 1 ; i <= index_m - 1  ; i ++ ) {
	//      	cout << i << "(" << nodes[0] + i - index_m + 1  << ")";
	nodes[ nodes[0] - index_m + + i + 1 ] = wk[i];
      }
      index_del(wk);
      //      cout << endl;
    }
  }
  return;
}


// nodes1をnodes2に加える
void add_node(int *nodes1, int *nodes2) {
  int count = nodes2[0];
  for(int i = 1; i <= nodes1[0]; i ++ ) {
    if(grep_node(nodes1[i],nodes2) == 0 ) {
      nodes2[0] ++;
      count ++;
      //      nodes2 = (int*)realloc(nodes2,count*sizeof(int));
      nodes2[nodes2[0]] = nodes1[i];
    }
  }
}

int grep_edge(int **edges, int a, int b) {
  for(int i = 1; i<= edges[0][0] ; i ++ ) {
    if( edges[i][0] == a && edges[i][1] == b ) { 
      return 1;
    }
  }
  return 0;
}

int check_finished_edge(int **edges, int *index, int edge1, int edge2) {
  int a,b,wk;
  a = edge1;
  b = edge2;  
  if( a > b ) {
    wk = a;
    a = b;
    b = wk;
  }

  //  cout << "check_finished_edge" <<  index[a] << ":" << index[b] << endl;
  for(int i = 1; i<= edges[0][0] ; i ++ ) {
    if( edges[i][0] == index[a] && edges[i][1] == index[b] ) { 
      return 1;
    }
  }
  return 0;
}

int check_edge(int **edges, int *edge, int *index) {
  int a,b;
  a = index[edge[0]];
  b = index[edge[1]];
  for(int i = 1; i<= edges[0][0] ; i ++ ) {
    if( edges[i][0] == a && edges[i][1] == b ) { 
      return 1;
    }
  }
  return 0;
}

int path_grep(int *path, pathlist pathlists) {

  int i,j,flg;

  for(i = 0; i<pathlists.count  ; i ++ ) {
    if(path[0] == pathlists.list[i][0]) {
      flg = 0;
      //      cout << path[0] << "-" <<   pathlists.list[i][0] << endl;
      for(j = 1; j <= path[0] ; j++ ) {
	//	cout << path[j] << ":" <<  pathlists.list[i][j] << endl;
	if(path[j] != pathlists.list[i][j] ) 
	  flg = 1;
      }

      if(flg == 0 ) 
	return i;
    }
  }
  return -1;
}

// a,bの接続情報をedgesに加える
void add_edge(int **edges, int edge1, int edge2) {
  int a,b,wk;
  a = edge1;
  b = edge2;
  if( a > b ) {
    wk = a;
    a = b;
    b = wk;
  }
  for(int i = 0; i <= edges[0][0]; i ++ ) {
    if(grep_edge(edges,a,b) == 0 ) {
      edges[0][0] ++;
      edges[edges[0][0]][0] = a;
      edges[edges[0][0]][1] = b;
    }
  }
}


void add_path(int *nodes, pathlist paths) {
  paths.count ++;
  paths.list[paths.count-1] = nodes;
}

// パスリスト比較(ただしソート済みの配列を仮定している
int compair_nodes(int *nodes1, int *nodes2) {
  if(nodes1[0] != nodes2[0] ) return 0;
  for(int i = 1; i<=nodes1[0] ; i ++ ) {
    if(nodes1[i] != nodes2[i]) return 0;
  }
  return 1;
}

void correspond_index(int *news, int *org,int *index){
  news[0] = org[0];
  for(int i = 1; i <= org[0] ; i++)
    news[i]= index[org[i]];
}

// 補集合
// All Setを与えて補集合をとろうとしたんだけど、やめ
int *complymentary_set(int *list, int members) {
  int *tmpnodes;
  tmpnodes = index_new(members + 1);
  tmpnodes[0] = 0;
  for(int i = 0; i< members ; i ++) {
    if(grep_node(i,list) == 0 ) {
      tmpnodes[0] ++;
      tmpnodes[tmpnodes[0]] = i;
    }
  }
  return tmpnodes;
}

// 与えられたノード群に隣接するノードを加える
// 0文字目はノード数 
// 追加したノード数を返す。
int add_neighbor_node(int *nodes, int **a , int dim) {
  int *tmpnodes;
  tmpnodes = index_new(dim + 1);
  int i,j,count,point;
  count = 0;
  for(i = 0; i<= nodes[0]; i ++ ) {
    tmpnodes[i] = nodes[i];
  }
  for(i = 1; i <=tmpnodes[0]; i ++ ) {
    point = tmpnodes[i];
    for( j = 0 ; j < dim ; j ++ ) {
      if( a[point][j] != 0 && grep_node(j,nodes) == 0) {
	nodes[0] ++ ;
	count ++;
	nodes[nodes[0]] = j ;
      }
    }
  }
  index_del(tmpnodes);
  return count;
}


int xor_path(int *path1, int *path2 ) {

  int count;
  int res = -1;
  count = 0;

  //  cout << " check:" << path1[0] << ":" << path2[0] << endl;

  for(int i = 1; i <= path1[0] ; i ++ ) {
    //    cout << "i = " << i << " ";
    for(int j = 1; j <= path2[0] ; j ++ ) {
      //      cout << "j = " << j << " " << path1[i] << "/" << path2[j] << " ";
      if( path1[i] == path2[j] )  
	count ++;
    }
    //    cout << endl;
  }

  if(count > 0 ) {

    if( count == path1[0] && path1[0] == path2[0] ) {

      // 二つのパスが一致している場合
      //        cout << " icchi " << endl;
      res = 0;

    } else {
      res = count;
    }
  }
  //  cout << "end" << endl;
  return res;
}


// 与えられたノードにつながる全てのノードを返す。
// 0文字目はノード数 
// 追加したノード数を返す
void search_pathway(int *nodes ,int *innodes, int **a , int dim) {
  int count;
  count = 1;
  for( int i=0;i<=innodes[0];i++) {
    nodes[i] = innodes[i];
  }
  while( count != 0){
    count = add_neighbor_node(nodes,a,dim);
  }
}

/*
void get_isolatedring(int **a , int dim  , int flg) {
  int *hubs;

  hubs = search_hubnode(**a , dim , 1); 
  for(int i = 0; i<=hubs[0] ; i ++ ) {
    printf("node %d : Hub %d\n",i,hubs[i]);
    
  }

}
*/
// 行列から0列/行を取り除く
int matrix_degeneracy(int **mat_a ,int *index , int dim  , int flg) {
  int d,w1,i1,i,j;

  i1 = 0;
  d = matrix_nonzero_rows(mat_a, dim , dim , flg);
  int *bkindex;
  bkindex = index_new(dim);
  int *wkindex;
  wkindex = index_new(d);

  for(i=0;i<dim;i++) {
    bkindex[i] = index[i];
    //    cout << "index : " <<  index[i] << endl;
  }
  for(i=0;i<dim;i++) {
    w1 = 0;
    for(j = 0 ; j < dim ; j ++) {
      if( i != j || flg != 0 ) {
	if(mat_a[i][j] != 0 ) {
	  w1 = 1;
	}
      }
    }
    if(w1 != 0 ) {
      index[i1] = bkindex[i]; // オリジナルの配列の何番目か
      wkindex[i1] = i; // 前の配列の何番目か
      //      printf("org:%d-new:%d index ret:%d-wk:%d\n",i1,i,bkindex[i],wkindex[i1]);
      i1 ++;
    }
  }
  /*
  printf("\n------- original -------\n");
  print_index(retindex, d);
  printf("--------------------\n");
  printf("\n-------   works --------\n");
  print_index(wkindex, d);
  printf("--------------------\n");
  */

  int **wk;
  wk = matrix_copy(mat_a,dim,dim); // 接続行列を複製
  //  matrix_del(mat_a,dim); // 接続行列を解放する
  //  mat_a = matrix_new(d,d); // 接続行列を再定義する
    //  cout << "<<     setmatrix" << endl;

  for(i=0;i<d;i++) {
    for(j=0;j<d;j++){
      //      cout << i << ":" << j << ":" << wk[wkindex[i]][wkindex[j]] << endl;
      mat_a[i][j] = wk[wkindex[i]][wkindex[j]]; 
    }
  }
  //  cout << "<<     del mat" << endl;
  matrix_del(wk,dim); // wk接続行列を解放する
  index_del(wkindex);
  index_del(bkindex);
  return d;
}

// エッジを１つだけ消去する。
int delete_edge(int *del, int **a,int dim ){
  if( a[del[0]][del[1]] != 0) {
	a[del[0]][del[1]] = 0;
	a[del[1]][del[0]] = 0;
	return 1;
  } 
  return 0;
}

// ノードを１つ消去する。
int delete_node(int del, int **a,int dim ){
  if( del > dim ) {
    return 0;
  } else {
    for( int i = 0 ; i < dim ; i ++ ) {
      a[del][i] = 0;
      a[i][del] = 0;
    }
  }
  return 1; 
}

// ini と 接続しているエッジを一本消去する。

int check_out_Edge( int ini, int **a, int dim , int *path){

  int del = -1 ;

  if( ini > dim || path[0] < 2 ) {
    return 0;
  } else {
    for( int i = 1 ; i < path[0] ; i ++ ) {
      if ( a[ini][i] != 0 &&  a[i][ini] != 0 ) { // 念のため対角側もチェック
	del = i;
      }
    }
    if( del == -1 ) {
      return 0;
    } else {
      a[ini][del] = 0;
      a[del][ini] = 0;
    }
  }
  return 1; 
}

int diff_path( int *a, int *b) {
  int res = 0;
  for( int i = 1 ; i <= a[0] ; i ++ ) {
    for( int j = 1 ; j <= b[0] ; j ++ ) {
      if( a[i] == b[j] ) 
	res ++;
    }
  }
  return res;
}

////////////
