// cpdformat.c
//
// 10 October 2003 K.Tonomura
//

#include "t_matrix.h"

int **matrix_new(int row, int col)
{
  int **a = (int**)malloc(row*sizeof(int*));
  if( a == 0 ) {
    cout << "メモリ領域の確保に失敗しました。" << endl;
    exit(1);
  } else {
    for(int i = 0; i < row; i++) {
      a[i] = (int*)malloc(col*sizeof(int));
      if(a[i] == 0){
	while(--i >= 0) free(a[i]);
	free(a);
	cout << "メモリー領域の確保に失敗しました";
	exit (1);
      }
    }
  }
  return a; // アドレスを返す
}

int *index_new(int row)
{
  int *a = (int*)malloc(row*sizeof(int));
  for(int i = 0 ; i < row ; i++ ) 
    a[i] = 0;
  if( a == 0 ) {
    cout << "メモリ領域の確保に失敗しました。" << endl;
    exit(1);
  }
  return a; // アドレスを返す
}


//行列の解放
void matrix_del(int **a, int row)
{
  for(int i = 0; i < row; i++)
    free(a[i]);
  free(a);

}

void index_del(int *a)
{
  free(a);
}

//行列のコピー
int **matrix_copy(int **a, int row, int col )
{
 
  int **b;
  int i,j;
  b = matrix_new( row, col );

  for(i=0; i< row ; i++) {
    for(j=0; j< col ; j++) {
      b[i][j] = a[i][j]; 
    }
  }
	
  return b; // アドレスを返す
}

int *index_copy(int *a, int row )
{
 
  int *b;
  int i;
  b = index_new( row );

  for(i=0; i< row ; i++) {
    b[i] = a[i]; 
  }
	
  return b; // アドレスを返す
}


//行列の設定(単位行列)
void matrix_init(int **a, int row)
{
  for(int i = 0; i < row; i++){
    for(int j = 0; j < row; j++) {
      if(i == j ) {
	a[i][j] = 1;
      } else {
	a[i][j] =0;
      }
    }
  }
}

//行列の設定(零行列)
void matrix_zero(int **a, int row)
{
  for(int i = 0; i < row; i++){
    for(int j = 0; j < row; j++) 
      a[i][j] =0;
  }
}

void print_matrix(int **a, int row, int col)
{
    for(int i = 0; i < row; i++){
        for(int j = 0; j < col; j++)
            cout << " " << a[i][j];

        cout << endl;  //行の終わりに改行
    }
}

void print_index(int *a, int row)
{
    for(int i = 0; i < row; i++)
      cout << i << " " << a[i] << endl;

    cout << endl;  //行の終わりに改行
}

// インデックス配列の生成
void set_index_matrix(int **a, int dim)
{
  for(int i = 0; i < dim; i++){ 
      a[i][0] =i;
      a[i][1] =i;
  }
}

// 行列の0ベクトルでないrow

int matrix_nonzero_rows(int **a, int row, int col ,int flg) {
  int i,j,line,count;
  count = 0;
  for(j=0; j < row ; j++ ) {
    line = 0;
    for(i = 0; i < col ; i++) {
      if(a[i][j] != 0 ) {
	if( i != j || flg != 0 ) {
	  line = 1;
	}
      }
    }
    if(line == 1 ) { count ++ ; }
  }
  return count;
}
